<?php
$photopress_url = get_bloginfo('wpurl') . '/wp-content/plugins/photopress';

function photopress_mce_buttons($buttons) {
	array_push($buttons, "photopress"); // nothing special here, just add button names, using separators as needed
	return $buttons;
}

function photopress_mce_external_plugins($plugins) {
	global $photopress_url;
	$plugins['photopress'] = $photopress_url . '/tinymce/v3/editor_plugin.js';
	return $plugins;
}

// Add quicktags for html source editor. To add more buttons, replicate the stuff between the Start and End comments. Hiding button when TinyMCE is present because it does not work.
function photopress_add_quicktags() {
echo <<<EOT
<script type="text/javascript">
// <![CDATA[
	if ( typeof tinyMCE == "undefined") {
	if(photopressToolbar = document.getElementById("ed_toolbar")){
		var photopressNr, photopressBut, photopressStart, photopressEnd;
		// Start button 1
		photopressStart = '';
		photopressEnd = '';
		photopressNr = edButtons.length;
		edButtons[photopressNr] = new edButton('ed_photopress0','Photos','', '','','-1');
		var photopressBut = photopressToolbar.lastChild;
		while (photopressBut.nodeType != 1){
			photopressBut = photopressBut.previousSibling;
		}
		photopressBut = photopressBut.cloneNode(true);
		photopressToolbar.appendChild(photopressBut);
		photopressBut.value = 'Photos';
		photopressBut.title = 'Upload and insert images';
		photopressBut.onclick = function() {edPhotopress();}
		photopressBut.id = "ed_photopress0";							
		photopressStart = '';
		photopressEnd = '';
		// End button 1
	}
	}

// ]]>
</script>
EOT;
}
// Load the javascript for the popup tool. This runs when the button is clicked - it launches the Photopress popup tool.
function photopress_popup_javascript() {
	global $photopress_url;
	echo '
<script type="text/javascript">
//<![CDATA[
function edPhotopress() {
   var mylink = "' . $photopress_url . '/popup.php?action=upload";
   var windowname = "photopress";
   if (! window.focus) return true;
      var href;
   if (typeof(mylink) == "string")
      href = mylink;
   else
      href = mylink.href;
   ppopupwin = window.open(href, windowname, "width=400,height=600,scrollbars=yes,toolbar=no,menubar=no,resizable=yes");
   ppopupwin.focus();
   return false;
}
//]]>
</script>
';
}

// Actions and filters to connect the plugin with WP.
add_action('admin_print_scripts', 'photopress_popup_javascript');
add_action('admin_footer', 'photopress_add_quicktags');
add_filter( 'mce_external_plugins', 'photopress_mce_external_plugins');
add_filter( 'mce_buttons_3', 'photopress_mce_buttons');

?>
